' Cordic Test (needs PropTerminal on PC)
' Andy Schenk, Dec 2012
'
' press "s","c" or "r" for sine,cosine and random graph

CON
  TX = 90
  RX = 91
  baud = 115200
  clkfrq = 60_000_000

DAT
        org 0
loop    call #chinp             'wait for keypress -> t1

        cmp t1,#"q"  wz         'quit (to monitor)
  if_z  jmp #exit

        mov x,#0
        mov count,#256
:nxt
        cmp t1,#"s"  wz         'sine
  if_z  qsincos x,magn          'start CORDIC sin/cos with angle,magn
  if_z  getqy y                 'getqy=sin

        cmp t1,#"c"  wz         'cosine
  if_z  qsincos x,magn          'start CORDIC sin/cos with angle,magn
  if_z  getqx y                 'getqx=cos

        cmp t1,#"r"  wz         'random lfsr
  if_z  getlfsr y
  if_z  sar y,#16

        pusha y                 'store to CLUT
        add x,bit24             'inc angle
        djnz count,#:nxt

        mov t1,#0               'cls
        call #chout
        call #curv              'draw result
        jmp #loop


'--- terminal functions ----

curv    setspa #0               'draw graph from data in CLUT
        mov x,#255
        mov y,#128
        movs grmd,#1            'plot mode
:zero   call #plot              'draw zero line
        sub x,#2
        djnz x,#:zero
        mov x,#0
:loop   popar y                 'repeat 256 datas
        sar y,#9                'scale
        subr y,#128             'screen y offset
        call #plot
        add x,#1
        movs grmd,#2            'drawTo mode
        cmp x,#255  wc
  if_b  jmp #:loop
        movs grmd,#1            'restore plot mode
curv_ret ret

plot    mov t1,#5               'draw a pixel at x,y
        call #chout
grmd    mov t1,#1               '0=at 1=plot 2=drawTo 3=box 7=circle 8=rbox
        call #chout
        mov t1,x
        call #chout
        mov t1,y
        call #chout
plot_ret ret

chout   setp #TX                'TX=output and high
        or  t1,#$100            'add stopbit
        shl t1,#1               'add startbit
        mov bits,#10
        getcnt tm
        add tm,baudt
:bit    shr t1,#1  wc           'shift bits
        setpc #TX               'and send over TX
        waitcnt tm,baudt        'wait 1 bittime
        djnz bits,#:bit         'all bits done?
        waitcnt tm,baudt        '2 stopbits
chout_ret ret

chinp   getp #RX  wc            'receive a character
  if_c  jmp #chinp
        getcnt tm
        add tm,baudt
        mov t1,baudt
        shr t1,#1
        add tm,t1               '1.5 bit time
        mov bits,#8
        mov t1,#0
:bit    waitcnt tm,baudt        'wait bittime
        getp #RX  wc            'read bits in
        shr t1,#1
        setbc t1,#7
        djnz bits,#:bit         'all bits done?
        waitcnt tm,baudt        'wait for stopbit
chinp_ret ret

exit    coginit monitor,monpins  'relaunch cog0 with monitor

monitor long $70C
monpins long 90<<9 + 91

baudt   long clkfrq / baud
tm      long 0
bits    long 0
t0      long 0
t1      long 0
x       long 0
y       long 0
count   long 0
magn    long 19000
bit24   long 1<<24